package com.example.viewpage;

import java.util.regex.Pattern;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Typeface;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.view.View;
/*
 *ListVIewҲർ
 */
public class MySideBar extends View {

    //Ƿ
	private boolean showBkg = false;
	//Ƿӿ
	OnTouchingLetterChangedListener onTouchingLetterChangedListener;
	// 26ĸ
	public static String[] b = { "#", "A", "B", "C", "D", "E", "F", "G", "H",
			"I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U",
			"V", "W", "X", "Y", "Z" };
    //ѡֵ
	int choose = -1;
	//
	Paint paint = new Paint();

	public MySideBar(Context context, AttributeSet attrs, int defStyle) {
		super(context, attrs, defStyle);
	}

	public MySideBar(Context context, AttributeSet attrs) {
		super(context, attrs);
	}

	public MySideBar(Context context) {
		super(context);
	}

	/**
	 * д
	 */
	protected void onDraw(Canvas canvas) {
		super.onDraw(canvas);
		//崦ڵ״̬ͽıɫΪɫ
		if (showBkg) {
			canvas.drawColor(Color.parseColor("#40000000"));
		}
        //ã֣ĸ
		int height = getHeight();
		  //ã֣Ŀ
		int width = getWidth();
		//óÿһŵĸ߶
		int singleHeight = height / b.length;
		for (int i = 0; i < b.length; i++) {
		    //þ
			paint.setAntiAlias(true);
			//С
			paint.setTextSize(15);
			  //26ĸеһȾ
			if (i == choose) {
				//ƵɫΪɫ
				paint.setColor(Color.parseColor("#3399ff"));
				paint.setFakeBoldText(true);
			}
			//õX
			float xPos = width / 2 - paint.measureText(b[i]) / 2;
			//õY
			float yPos = singleHeight * i + singleHeight+3;
		    //Ƶ
			canvas.drawText(b[i], xPos, yPos, paint);
			 //ԭ
			paint.reset();
		}

	}

    /**
     * ¼
     */
	@Override
	public boolean dispatchTouchEvent(MotionEvent event) {
		//õ״̬
		final int action = event.getAction();
		//Y
		final float y = event.getY();
		
		final int oldChoose = choose;
		//
		final OnTouchingLetterChangedListener listener = onTouchingLetterChangedListener;
	    //õǰֵ
		final int c = (int) (y / getHeight() * b.length);
        //ݵ״̬ͬͬĴ
		switch (action) {
		//Ѿʼ
		case MotionEvent.ACTION_DOWN:
			//Ϊtrue
			showBkg = true;
			if (oldChoose != c && listener != null) {
				if (c > 0 && c < b.length) {
					//ǰֵ󶨼  ڱҳǽӿڡʵʵMainActivСҲ˵ǵӿڻִMainActivtiyķ
					listener.onTouchingLetterChanged(b[c]);
					choose = c;
					//ˢ½
					invalidate();
				}
			}

			break;
			//ɿΪɵ
		case MotionEvent.ACTION_MOVE:
			if (oldChoose != c && listener != null) {
				if (c > 0 && c < b.length) {
					listener.onTouchingLetterChanged(b[c]);
					choose = c;
					invalidate();
				}
			}
			break;
		//ɿ  ԭ ˢ½
		case MotionEvent.ACTION_UP:
			showBkg = false;
			choose = -1;
			invalidate();
			break;
		}
		return true;
	}

	@Override
	public boolean onTouchEvent(MotionEvent event) {
		return super.onTouchEvent(event);
	}

	/**
	 * ⹫ķ
	 * 
	 * @param onTouchingLetterChangedListener
	 */
	public void setOnTouchingLetterChangedListener(
			OnTouchingLetterChangedListener onTouchingLetterChangedListener) {
		this.onTouchingLetterChangedListener = onTouchingLetterChangedListener;
	}

	/**
	 * ӿ
	 * 
	 * @author coder
	 * 
	 */
	public interface OnTouchingLetterChangedListener {
		public void onTouchingLetterChanged(String s);
	}

}
